<template>
  <SwPluginSlot name="gs-navigation-bottom" class="sw-gs-navigation-bottom sw-gs-nav-overlay" :class="navPositionClass">
    <SwPluginSlot name="gs-navigation-bottom-last-seen"
                  class="sw-gs-navigation-bottom-action">
      <SwButton class="sf-button sw-gs-open-last-seen color-light is-circle"
                :title="$t('Last seen products')"
                @click.capture="clickHandler(1)">
        <SwGsIconLastSeen class="color-dark-secondary size-sm"/>
      </SwButton>
    </SwPluginSlot>

    <template v-if="currentClientForGuide || isClient">

      <SwPluginSlot name="gs-navigation-client-actions-before"
                    class="sw-gs-navigation-bottom-action is-before"/>

      <SwPluginSlot name="gs-navigation-bottom-like-list"
                    class="sw-gs-navigation-bottom-action"
                    :slotContext="likedCount">
        <SwButton class="sf-button sw-gs-open-like-list color-light is-circle"
                  :title="$t('Like list')"
                  @click.capture="clickHandler(2)">
          <SwGsIconThumbsUp class="color-dark-secondary size-sm"/>
          <SfBadge v-if="likedCount > 0" class="sf-badge--number liked-badge">{{
              likedCount
            }}
          </SfBadge>
        </SwButton>
      </SwPluginSlot>

      <SwPluginSlot name="gs-navigation-bottom-cart"
                    class="sw-gs-navigation-bottom-action"
                    :slotContext="showCartCount">
        <SwButton class="sf-button sw-gs-open-cart color-light is-circle"
                  :title="$t('Cart')"
                  :class="{'no-permissions': !(isClient || currentClientCartPermissions)}"
                  @click.capture="clickHandler(3)">
          <SwGsIconCart class="size-sm"/>
          <SfBadge v-if="showCartCount > 0" class="sf-badge--number cart-badge" :class="{disabled: disableCartCount}">{{
              showCartCount
            }}
          </SfBadge>
        </SwButton>
      </SwPluginSlot>

      <SwPluginSlot name="gs-navigation-client-actions-after"
                    class="sw-gs-navigation-bottom-action is-after"/>

    </template>

    <SwPluginSlot v-if="isGuide && !isSelfService"
                  name="gs-navigation-select-user-to-act-for"
                  class="gs-navigation-select-user-to-act-for">
        <SwGsSelectClientForGuide/>
    </SwPluginSlot>
  </SwPluginSlot>
</template>

<script lang="ts">
  import SwPluginSlot from "sw-plugins/SwPluginSlot.vue"
  import {SfBadge} from "@storefront-ui/vue"
  import SwButton from "@/components/atoms/SwButton.vue"
  import {useUIState} from "@shopware-pwa/composables"
  import {useTabsUIState} from "../../logic/composables/useTabsUIState"
  import {useLikeList} from "../../logic/composables/useLikeList";
  import {SwGsIconCart, SwGsIconLastSeen, SwGsIconThumbsUp} from "../icons";
  import SwGsSelectClientForGuide from "../SwGsSelectClientForGuide.vue";
  import {useAppointment} from "../../logic/composables/useAppointment";
  import {useState} from "../../logic/composables/useState";
  import {useGsCart} from "../../logic/composables/useGsCart";
  import { computed } from "@vue/composition-api"
  import {usePresentationLayer} from "../../logic/composables/usePresentationLayer";

  export default {
    name: "SwGsNavigationBottom",
    components: {
      SwGsIconLastSeen,
      SwGsIconCart,
      SwGsIconThumbsUp,
      SwPluginSlot,
      SfBadge,
      SwButton,
      SwGsSelectClientForGuide
    },

    setup() {
      const {switchState: toggleOffcanvas, isOpen} = useUIState({stateName: "GS_OFFCANVAS_SIDEBAR_STATE"});
      const {switchState: changeActiveTab, activeTab} = useTabsUIState({stateName: "GS_OFFCANVAS_TABS_STATE"});
      const {likedCount} = useLikeList();
      const {isGuide, isClient, isSelfService} = useAppointment();
      const {currentClientForGuide} = useState();
      const {count: cartCount, disabledCartCount, currentClientCartPermissions} = useGsCart();
      const { navPositionClass } = usePresentationLayer();

      function clickHandler(tabNumber) {
        // change tab if offcanvas is open and tabNumber is different
        if (isOpen.value && activeTab.value !== tabNumber) {
          changeActiveTab(tabNumber);
          return;
        }

        toggleOffcanvas();
        changeActiveTab(tabNumber);
      }

      return {
        toggleOffcanvas,
        changeActiveTab,
        clickHandler,
        likedCount,
        isGuide,
        isClient,
        isSelfService,
        navPositionClass,
        currentClientForGuide,
        currentClientCartPermissions,
        showCartCount: computed(() => cartCount.value || disabledCartCount.value || 0),
        disableCartCount: computed(() => !cartCount.value)
      }
    }
  }
</script>

<style lang="scss" scoped>
  @use "sass:math";
  @import "@/assets/scss/variables";

  .sw-gs-navigation-bottom {
    display: flex;
    position: fixed;
    z-index: var(--navigation-z-index);
    bottom: var(--spacer-sm);
    left: calc(50%);
    transform: translateX(-50%);

    &.layer-minimized {
      left: calc(50% - (var(--presentation-layer-width-minimized) / 2));
      transition: left 0.3s ease-in-out;
    }

    @include for-tablet {
      &.layer-maximized {
        left: calc(50% - (var(--presentation-layer-width-maximized) / 2));
        transition: left 0.3s ease-in-out;
      }
    }

    .sf-button {
      min-width: 46px;
      min-height: 46px;
    }

    .gs-navigation-select-user-to-act-for,
    .sw-gs-navigation-bottom-action  {
      margin-left: var(--spacer-xs);
      &:first-of-type {
        margin-left: 0;
      }
    }

    .sw-gs-open-cart {
      --icon-color: var(--c-dark-variant);

      .sf-badge--number {
        &.disabled {
          --badge-background: var(--c-gray);
          color: var(--c-white);
        }
      }

      &.no-permissions {
        --icon-color: var(--c-gray);
      }
    }
  }

  .liked-badge,
  .cart-badge {
    position: absolute;
    right: 0;
    top: 0;
  }

</style>
